#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static char pushtoken[1024]={ 0 };

void pushback(char *token)
{
  strcpy(pushtoken,token);
}

int gettoken(FILE *in, char *token)
{
int ptr,ch;
int c;

  if (pushtoken[0]!=0)
  {
    strcpy(token,pushtoken);
    pushtoken[0]=0;
    return strlen(token);
  }

  ptr=0;

  while(1)
  {
    ch=getc(in);
    if (ch==EOF) break;
    if (ch=='\r' || ch=='\n' || ch=='\t' || ch==' ')
    {
      if (ptr==0) continue;
      break;
    }

    if ((ch>='a' && ch<='z') || (ch>='A' && ch<'Z') ||
        (ch>='0' && ch<='9') || ch=='_')
    {
      token[ptr++]=ch;
    }
      else
    {
      if (ptr!=0)
      {
        ungetc(ch,in);
        break;
      }

      if (ch=='"')
      {
        token[ptr++]=ch;

        while(1)
        {
          ch=getc(in);
          token[ptr++]=ch;
          if (ch==EOF || ch=='"') break;
        }
        break;
      }
        else
      if (ch=='|' || ch=='&' || ch=='+' || ch=='=' || ch=='-')
      {
        token[ptr++]=ch;

        c=getc(in);
        if (c==ch)
        { token[ptr++]=c; }
          else
        { ungetc(c,in); }

        break;
      }
        else
      if (ch=='!')
      {
        token[ptr++]=ch;

        c=getc(in);
        if (c=='=')
        { token[ptr++]=c; }
          else
        { ungetc(c,in); }

        break;

      }
        else
      if (ch=='/')
      {
        c=getc(in);
        if (c=='/')
        {
          while(1)
          {
            ch=getc(in);
            if (ch==EOF || ch=='\r' || ch=='\n') break;
          }
        }
          else
        if (c=='*')
        {
          while(1)
          {
            ch=getc(in);
            if (ch==EOF) break;
            if (ch=='*')
            {
              c=getc(in);
              if (c=='/') break;
              ungetc(c,in);
            }
          }
        }
          else
        {
          token[ptr++]=ch;
          ungetc(ch,in);
        }
      }
        else
      {
        token[ptr++]=ch;
        break;
      }
    }
  }

  token[ptr]=0;

  return ptr;
}


